/*
 * Hypercube API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.2.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package it.nextworks.nfvmano.sbi.starfish.api;

import it.nextworks.nfvmano.sbi.starfish.ApiCallback;
import it.nextworks.nfvmano.sbi.starfish.ApiClient;
import it.nextworks.nfvmano.sbi.starfish.ApiException;
import it.nextworks.nfvmano.sbi.starfish.ApiResponse;
import it.nextworks.nfvmano.sbi.starfish.Configuration;
import it.nextworks.nfvmano.sbi.starfish.Pair;
import it.nextworks.nfvmano.sbi.starfish.ProgressRequestBody;
import it.nextworks.nfvmano.sbi.starfish.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import it.nextworks.nfvmano.sbi.starfish.model.Gateway;
import it.nextworks.nfvmano.sbi.starfish.model.NetworkSliceQualityEnum;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class PlatformApi {
    private ApiClient apiClient;

    public PlatformApi() {
        this(Configuration.getDefaultApiClient());
    }

    public PlatformApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for createNetworkSlicePlatformNetworkslicePost
     * @param name  (required)
     * @param quality  (required)
     * @param subnetIp  (required)
     * @param gatewayIp  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createNetworkSlicePlatformNetworkslicePostCall(String name, NetworkSliceQualityEnum quality, String subnetIp, String gatewayIp, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/platform/networkslice";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (name != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("name", name));
        if (quality != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("quality", quality));
        if (subnetIp != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("subnet_ip", subnetIp));
        if (gatewayIp != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("gateway_ip", gatewayIp));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "OAuth2PasswordBearer" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createNetworkSlicePlatformNetworkslicePostValidateBeforeCall(String name, NetworkSliceQualityEnum quality, String subnetIp, String gatewayIp, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'name' is set
        if (name == null) {
            throw new ApiException("Missing the required parameter 'name' when calling createNetworkSlicePlatformNetworkslicePost(Async)");
        }
        // verify the required parameter 'quality' is set
        if (quality == null) {
            throw new ApiException("Missing the required parameter 'quality' when calling createNetworkSlicePlatformNetworkslicePost(Async)");
        }
        // verify the required parameter 'subnetIp' is set
        if (subnetIp == null) {
            throw new ApiException("Missing the required parameter 'subnetIp' when calling createNetworkSlicePlatformNetworkslicePost(Async)");
        }
        // verify the required parameter 'gatewayIp' is set
        if (gatewayIp == null) {
            throw new ApiException("Missing the required parameter 'gatewayIp' when calling createNetworkSlicePlatformNetworkslicePost(Async)");
        }
        
        com.squareup.okhttp.Call call = createNetworkSlicePlatformNetworkslicePostCall(name, quality, subnetIp, gatewayIp, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Create Network Slice
     * 
     * @param name  (required)
     * @param quality  (required)
     * @param subnetIp  (required)
     * @param gatewayIp  (required)
     * @return String
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public String createNetworkSlicePlatformNetworkslicePost(String name, NetworkSliceQualityEnum quality, String subnetIp, String gatewayIp) throws ApiException {
        ApiResponse<String> resp = createNetworkSlicePlatformNetworkslicePostWithHttpInfo(name, quality, subnetIp, gatewayIp);
        return resp.getData();
    }

    /**
     * Create Network Slice
     * 
     * @param name  (required)
     * @param quality  (required)
     * @param subnetIp  (required)
     * @param gatewayIp  (required)
     * @return ApiResponse&lt;String&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<String> createNetworkSlicePlatformNetworkslicePostWithHttpInfo(String name, NetworkSliceQualityEnum quality, String subnetIp, String gatewayIp) throws ApiException {
        com.squareup.okhttp.Call call = createNetworkSlicePlatformNetworkslicePostValidateBeforeCall(name, quality, subnetIp, gatewayIp, null, null);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create Network Slice (asynchronously)
     * 
     * @param name  (required)
     * @param quality  (required)
     * @param subnetIp  (required)
     * @param gatewayIp  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createNetworkSlicePlatformNetworkslicePostAsync(String name, NetworkSliceQualityEnum quality, String subnetIp, String gatewayIp, final ApiCallback<String> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createNetworkSlicePlatformNetworkslicePostValidateBeforeCall(name, quality, subnetIp, gatewayIp, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<String>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for platformGatewaysPlatformGatewaysGet
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call platformGatewaysPlatformGatewaysGetCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/platform/gateways";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "OAuth2PasswordBearer" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call platformGatewaysPlatformGatewaysGetValidateBeforeCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = platformGatewaysPlatformGatewaysGetCall(progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Platform Gateways
     * 
     * @return List&lt;Gateway&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Gateway> platformGatewaysPlatformGatewaysGet() throws ApiException {
        ApiResponse<List<Gateway>> resp = platformGatewaysPlatformGatewaysGetWithHttpInfo();
        return resp.getData();
    }

    /**
     * Platform Gateways
     * 
     * @return ApiResponse&lt;List&lt;Gateway&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Gateway>> platformGatewaysPlatformGatewaysGetWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = platformGatewaysPlatformGatewaysGetValidateBeforeCall(null, null);
        Type localVarReturnType = new TypeToken<List<Gateway>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Platform Gateways (asynchronously)
     * 
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call platformGatewaysPlatformGatewaysGetAsync(final ApiCallback<List<Gateway>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = platformGatewaysPlatformGatewaysGetValidateBeforeCall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Gateway>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
